http {
    # ssl
    ssl_protocols               TLSv1.2;
    ssl_ciphers                 ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256;
    ssl_prefer_server_ciphers   on;
    ssl_session_cache           shared:SSL:10m;
    ssl_session_timeout         10m;

    upstream backend {
        server      {{ upstream }};
        keepalive   32;
    }

    gzip                        on;
    gzip_types                  text/html application/json application/x-javascript;
    gzip_vary                   on;
    # gzip_proxied              expired no-cache no-store private auth;

    server {
        listen                  {{ ansible_default_ipv4.address }}:{{ listen_port | default(443) }} ssl http2 reuseport so_keepalive=on;
        access_log              /var/log/nginx/access.log;
        server_name             {{ server_name | default(ansible_fqdn) }};
        ssl_certificate         {{ cert_dir }}/{{ cert_name }}.crt;
        ssl_certificate_key     {{ cert_dir }}/{{ cert_name }}.key;

        location / {
            proxy_pass          http://backend;
            proxy_set_header    Host $host:$proxy_port;
            proxy_set_header    Accept-Encoding "";
            proxy_set_header    X-Forwarded-For $proxy_add_x_forwarded_for;
            proxy_http_version  1.1;
            proxy_set_header    Connection "";
        }
    }
}
